with Interfaces; use Interfaces;

package body CORBA_Repository_Root_TypedefDef_Hash is

   P : constant array (0 .. 3) of Natural :=
     (2, 4, 6, 9);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (16, 21, 2, 13);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (18, 7, 7, 0);

   G : constant array (0 .. 38) of Unsigned_8 :=
     (0, 2, 0, 3, 0, 6, 0, 0, 0, 3, 0, 0, 0, 13, 0, 16, 0, 0, 2, 0, 11, 4,
      16, 12, 0, 0, 0, 0, 18, 18, 7, 0, 0, 6, 17, 0, 10, 3, 0);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 39;
         F2 := (F2 + Natural (T2 (K)) * J) mod 39;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 19;
   end Hash;

end CORBA_Repository_Root_TypedefDef_Hash;
